﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;
using System.Data;

public partial class comboTemplates : System.Web.UI.Page
{
    protected void Page_Init(object sender, EventArgs e)
    {
        ddlSubListing.ItemTemplate = new ItemTemplate();
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            DataTable table = new DataTable();
            table.Columns.Add("col1");
            table.Columns.Add("col2");
            table.Columns.Add("col3");

            table.Rows.Add(new String[] {"item1", "col11", "col21"});
            table.Rows.Add(new String[] { "item2", "col12", "col22" });
            table.Rows.Add(new String[] { "item3", "col13", "col23" });

            ddlSubListing.DataTextField = "col1";
            ddlSubListing.DataSource = table;
            ddlSubListing.DataBind();            
        }

        foreach (RadComboBoxItem item in ddlSubListing.Items)
            item.DataBind();
    }

    class ItemTemplate : ITemplate
    {

        public void InstantiateIn(Control container)
        {
            Table table = new Table();
            table.Width = Unit.Percentage(100);
            TableRow mainRow = new TableRow();
            TableCell cell1 = new TableCell();
            cell1.DataBinding += new EventHandler(cell1_DataBinding);

            mainRow.Cells.Add(cell1);
            TableCell cell2 = new TableCell();
            cell2.DataBinding += new EventHandler(cell2_DataBinding);
            mainRow.Cells.Add(cell2);

            TableCell cell3 = new TableCell();
            cell3.DataBinding += new EventHandler(cell3_DataBinding);
            mainRow.Cells.Add(cell3);
            table.Rows.Add(mainRow);
            container.Controls.Add(table);
        }

        private void cell1_DataBinding(object sender, EventArgs e)
        {

            TableCell target = (TableCell)sender;
            RadComboBoxItem item = (RadComboBoxItem)target.BindingContainer;
            target.Text = (string)DataBinder.Eval(item, "Text");
        }

        private void cell2_DataBinding(object sender, EventArgs e)
        {
            TableCell target = (TableCell)sender;
            RadComboBoxItem item = (RadComboBoxItem)target.BindingContainer;
            target.Text = (string)DataBinder.Eval(item, "Attributes[\"col2\"]");
        }

        private void cell3_DataBinding(object sender, EventArgs e)
        {
            TableCell target = (TableCell)sender;
            RadComboBoxItem item = (RadComboBoxItem)target.BindingContainer;
            target.Text = (string)DataBinder.Eval(item, "Attributes[\"col3\"]");
        }

    }
    protected void Button1_Click(object sender, EventArgs e)
    {
        for (int i = 1; i < 5; i++)
        {

         RadComboBoxItem item = new RadComboBoxItem("item " + i.ToString());
            item.Attributes["col2"] = "col2_" + i.ToString();
            item.Attributes["col3"] = "col3_" + i.ToString();
            ddlSubListing.Items.Add(item);

        }
        ddlSubListing.DataBind();
    }
    protected void ddlSubListing_ItemDataBound(object sender, RadComboBoxItemEventArgs e)
    {
        DataRowView dataSourceRow = (DataRowView) e.Item.DataItem;
        e.Item.Attributes["col2"] = dataSourceRow["col2"].ToString();
        e.Item.Attributes["col3"] = dataSourceRow["col3"].ToString();
       
    }
}
